/**
 * <copyright>
 * </copyright>
 *
 * $Id: SimpleTypeImpl.java 6663 2010-09-29 13:07:18Z michael_clay $
 */
package org.openxma.dsl.core.model.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;
import org.openxma.dsl.common.DslConstants;
import org.openxma.dsl.core.CorePackage;
import org.openxma.dsl.core.model.Editor;
import org.openxma.dsl.core.model.ParameterDefinition;
import org.openxma.dsl.core.model.SimpleType;
import org.openxma.dsl.core.model.TypeDefinition;
import org.openxma.dsl.core.model.ValidatorReference;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Simple Type</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.openxma.dsl.core.model.impl.SimpleTypeImpl#isCustom <em>Custom</em>}</li>
 *   <li>{@link org.openxma.dsl.core.model.impl.SimpleTypeImpl#getTypeParameter <em>Type Parameter</em>}</li>
 *   <li>{@link org.openxma.dsl.core.model.impl.SimpleTypeImpl#getValidatorReference <em>Validator Reference</em>}</li>
 *   <li>{@link org.openxma.dsl.core.model.impl.SimpleTypeImpl#getEditor <em>Editor</em>}</li>
 *   <li>{@link org.openxma.dsl.core.model.impl.SimpleTypeImpl#getTypeDefinition <em>Type Definition</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class SimpleTypeImpl extends TypeImpl implements SimpleType {
	/**
	 * The default value of the '{@link #isCustom() <em>Custom</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isCustom()
	 * @generated
	 * @ordered
	 */
	protected static final boolean CUSTOM_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isCustom() <em>Custom</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isCustom()
	 * @generated
	 * @ordered
	 */
	protected boolean custom = CUSTOM_EDEFAULT;

	/**
	 * The cached value of the '{@link #getTypeParameter() <em>Type Parameter</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTypeParameter()
	 * @generated
	 * @ordered
	 */
	protected EList<ParameterDefinition> typeParameter;

	/**
	 * The cached value of the '{@link #getValidatorReference() <em>Validator Reference</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getValidatorReference()
	 * @generated
	 * @ordered
	 */
	protected ValidatorReference validatorReference;

	/**
	 * The cached value of the '{@link #getEditor() <em>Editor</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEditor()
	 * @generated
	 * @ordered
	 */
	protected Editor editor;

	/**
	 * The cached value of the '{@link #getTypeDefinition() <em>Type Definition</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTypeDefinition()
	 * @generated
	 * @ordered
	 */
	protected TypeDefinition typeDefinition;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SimpleTypeImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return CorePackage.Literals.SIMPLE_TYPE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isCustom() {
		return custom;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCustom(boolean newCustom) {
		boolean oldCustom = custom;
		custom = newCustom;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CorePackage.SIMPLE_TYPE__CUSTOM, oldCustom, custom));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ParameterDefinition> getTypeParameter() {
		if (typeParameter == null) {
			typeParameter = new EObjectContainmentEList<ParameterDefinition>(ParameterDefinition.class, this, CorePackage.SIMPLE_TYPE__TYPE_PARAMETER);
		}
		return typeParameter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ValidatorReference getValidatorReference() {
		return validatorReference;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetValidatorReference(ValidatorReference newValidatorReference, NotificationChain msgs) {
		ValidatorReference oldValidatorReference = validatorReference;
		validatorReference = newValidatorReference;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, CorePackage.SIMPLE_TYPE__VALIDATOR_REFERENCE, oldValidatorReference, newValidatorReference);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setValidatorReference(ValidatorReference newValidatorReference) {
		if (newValidatorReference != validatorReference) {
			NotificationChain msgs = null;
			if (validatorReference != null)
				msgs = ((InternalEObject)validatorReference).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - CorePackage.SIMPLE_TYPE__VALIDATOR_REFERENCE, null, msgs);
			if (newValidatorReference != null)
				msgs = ((InternalEObject)newValidatorReference).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - CorePackage.SIMPLE_TYPE__VALIDATOR_REFERENCE, null, msgs);
			msgs = basicSetValidatorReference(newValidatorReference, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CorePackage.SIMPLE_TYPE__VALIDATOR_REFERENCE, newValidatorReference, newValidatorReference));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Editor getEditor() {
		if (editor != null && editor.eIsProxy()) {
			InternalEObject oldEditor = (InternalEObject)editor;
			editor = (Editor)eResolveProxy(oldEditor);
			if (editor != oldEditor) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, CorePackage.SIMPLE_TYPE__EDITOR, oldEditor, editor));
			}
		}
		return editor;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Editor basicGetEditor() {
		return editor;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setEditor(Editor newEditor) {
		Editor oldEditor = editor;
		editor = newEditor;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CorePackage.SIMPLE_TYPE__EDITOR, oldEditor, editor));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TypeDefinition getTypeDefinition() {
		return typeDefinition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetTypeDefinition(TypeDefinition newTypeDefinition, NotificationChain msgs) {
		TypeDefinition oldTypeDefinition = typeDefinition;
		typeDefinition = newTypeDefinition;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, CorePackage.SIMPLE_TYPE__TYPE_DEFINITION, oldTypeDefinition, newTypeDefinition);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setTypeDefinition(TypeDefinition newTypeDefinition) {
		if (newTypeDefinition != typeDefinition) {
			NotificationChain msgs = null;
			if (typeDefinition != null)
				msgs = ((InternalEObject)typeDefinition).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - CorePackage.SIMPLE_TYPE__TYPE_DEFINITION, null, msgs);
			if (newTypeDefinition != null)
				msgs = ((InternalEObject)newTypeDefinition).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - CorePackage.SIMPLE_TYPE__TYPE_DEFINITION, null, msgs);
			msgs = basicSetTypeDefinition(newTypeDefinition, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CorePackage.SIMPLE_TYPE__TYPE_DEFINITION, newTypeDefinition, newTypeDefinition));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case CorePackage.SIMPLE_TYPE__TYPE_PARAMETER:
				return ((InternalEList<?>)getTypeParameter()).basicRemove(otherEnd, msgs);
			case CorePackage.SIMPLE_TYPE__VALIDATOR_REFERENCE:
				return basicSetValidatorReference(null, msgs);
			case CorePackage.SIMPLE_TYPE__TYPE_DEFINITION:
				return basicSetTypeDefinition(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case CorePackage.SIMPLE_TYPE__CUSTOM:
				return isCustom();
			case CorePackage.SIMPLE_TYPE__TYPE_PARAMETER:
				return getTypeParameter();
			case CorePackage.SIMPLE_TYPE__VALIDATOR_REFERENCE:
				return getValidatorReference();
			case CorePackage.SIMPLE_TYPE__EDITOR:
				if (resolve) return getEditor();
				return basicGetEditor();
			case CorePackage.SIMPLE_TYPE__TYPE_DEFINITION:
				return getTypeDefinition();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case CorePackage.SIMPLE_TYPE__CUSTOM:
				setCustom((Boolean)newValue);
				return;
			case CorePackage.SIMPLE_TYPE__TYPE_PARAMETER:
				getTypeParameter().clear();
				getTypeParameter().addAll((Collection<? extends ParameterDefinition>)newValue);
				return;
			case CorePackage.SIMPLE_TYPE__VALIDATOR_REFERENCE:
				setValidatorReference((ValidatorReference)newValue);
				return;
			case CorePackage.SIMPLE_TYPE__EDITOR:
				setEditor((Editor)newValue);
				return;
			case CorePackage.SIMPLE_TYPE__TYPE_DEFINITION:
				setTypeDefinition((TypeDefinition)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case CorePackage.SIMPLE_TYPE__CUSTOM:
				setCustom(CUSTOM_EDEFAULT);
				return;
			case CorePackage.SIMPLE_TYPE__TYPE_PARAMETER:
				getTypeParameter().clear();
				return;
			case CorePackage.SIMPLE_TYPE__VALIDATOR_REFERENCE:
				setValidatorReference((ValidatorReference)null);
				return;
			case CorePackage.SIMPLE_TYPE__EDITOR:
				setEditor((Editor)null);
				return;
			case CorePackage.SIMPLE_TYPE__TYPE_DEFINITION:
				setTypeDefinition((TypeDefinition)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case CorePackage.SIMPLE_TYPE__CUSTOM:
				return custom != CUSTOM_EDEFAULT;
			case CorePackage.SIMPLE_TYPE__TYPE_PARAMETER:
				return typeParameter != null && !typeParameter.isEmpty();
			case CorePackage.SIMPLE_TYPE__VALIDATOR_REFERENCE:
				return validatorReference != null;
			case CorePackage.SIMPLE_TYPE__EDITOR:
				return editor != null;
			case CorePackage.SIMPLE_TYPE__TYPE_DEFINITION:
				return typeDefinition != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (custom: ");
		result.append(custom);
		result.append(')');
		return result.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public String getInstanceTypeName() {
		if (getTypeDefinition() != null) {
			if (getTypeDefinition().getDefinition() != null && getTypeDefinition().getDefinition().getDataType() != null
					&& getTypeDefinition().getDefinition().getDataType() instanceof SimpleType) {
				SimpleType parent = (SimpleType) getTypeDefinition().getDefinition().getDataType();
				return parent.getInstanceTypeName();
			}
			if (getTypeDefinition().getInstanceType() != null) {
				// Type is a implementation Class, so we will take it
				return substringJavaLangPackage(getTypeDefinition().getInstanceType());
			}
		}
		return null;
	}
	
	String substringJavaLangPackage(String s) {
		if(s.startsWith(DslConstants.PACKAGE_JAVA_LANG)) {
			return s.substring(DslConstants.PACKAGE_JAVA_LANG.length());
		}
		return s.replaceAll("\\^", "");
	}

} //SimpleTypeImpl
